//FRAGMENTSHADER_GENERATEDEPTHMAP
precision mediump float;


const vec4 bitSh = vec4(256.0*256.0*256.0, 256.0*256.0, 256.0, 1.0);
const vec4 bitMsk = vec4(0, 1.0/256.0, 1.0/256.0, 1.0/256.0);
const vec4 bitShifts = vec4(1.0 / (256.0 * 256.0 * 256.0), 1.0 / (256.0 * 256.0), 1.0 / 256.0, 1.0);

uniform float u_near;
uniform float u_far;

varying vec4 v_position;

vec4 pack(float depth)
{
	vec4 comp = fract(depth * bitSh);
	comp -= comp.xxyz * bitMsk;
	return comp;
}
float unpack(vec4 color)
{
	return dot(color, bitShifts);
}
vec4 pack2(float d1, float d2)
{
	vec4 result;
	result.x = fract(d1*256.0)*(1.0/256.0);
	result.y = fract(d1);
	result.z = fract(d2*256.0)*(1.0/256.0);
	result.w = fract(d2);
	return result;
}
vec2 unpack2(vec4 color)
{
	vec2 result;
	result.x = color.x*(1.0/256.0)+color.y;
	result.y = color.z*(1.0/256.0)+color.w;
	return result;
}
void main()
{
//	float normalizedDistance = (v_position.w-u_near)/(u_far-u_near);
	float normalizedDistance = ((v_position.z/v_position.w)+1.0)*0.5;
	vec4 packedDepth = pack(normalizedDistance);
//	vec4 packedDepth = pack(normalizedDistance);
//	vec4 packedDepth = pack2(normalizedDistance, normalizedDistance*normalizedDistance);


	gl_FragColor = packedDepth;
//	gl_FragColor = vec4(normalizedDistance, normalizedDistance*normalizedDistance, 0.0, 1.0);
}
