//FRAGMENTSHADER_MQO_TEXTURE;
precision mediump float;

uniform sampler2D u_tex1;
uniform vec4 u_materialAmbient;
uniform vec4 u_materialDiffuse;
uniform vec4 u_materialSpecular;
uniform float u_materialShininess;
uniform vec3 u_lightDirection;

varying vec2 v_uv;
varying vec3 v_position;
varying vec3 v_normal;


void main()
{
	vec3 normal = normalize(v_normal);
	vec3 cameraDirection = normalize(-v_position);
	float f = dot(u_lightDirection, normal)*0.5+0.5;
	vec4 diffuse = vec4(f, f, f, 1.0)*u_materialDiffuse;
	vec3 harfAngle = normalize(u_lightDirection + cameraDirection);
	float specularWeight = pow(max(0.001, dot(harfAngle, normal)), u_materialShininess);
	vec4 specular = max(specularWeight*u_materialSpecular, 0.0);
	vec4 color = min(min(u_materialAmbient+diffuse, 1.0)*texture2D(u_tex1, v_uv) + specular, 1.0);
	if(color.w > 0.0) {
		gl_FragColor = color;
	} else {
		discard;
	}
}
