//VERTEXTSHADER_DIRECT
uniform mat4 u_modelViewMatrix;
uniform mat4 u_projMatrix;
uniform mat4 u_shadowMVPMatrix;
uniform mat4 u_normalMatrix;

attribute vec3 a_position;
attribute vec3 a_normal;

varying vec4 v_shadowCoord;
varying vec3 v_normal;

const mat4 bias = mat4(
    0.5, 0.0, 0.0, 0.0, 
    0.0, 0.5, 0.0, 0.0,
    0.0, 0.0, 0.5, 0.0,
    0.5, 0.5, 0.5, 1.0);

void main()
{
	vec4 pos = vec4(a_position, 1.0);
	v_shadowCoord = u_shadowMVPMatrix*pos;
	v_normal = mat3(u_normalMatrix)*a_normal;
	gl_Position=u_projMatrix*u_modelViewMatrix*pos;
}
