//VERTEXTSHADER_GENERATENORMALMAP
uniform mat4 u_modelViewMatrix;
uniform mat4 u_normalMatrix;
uniform mat4 u_projMatrix;

attribute vec3 a_position;
attribute vec3 a_normal;

varying vec4 v_color;
varying vec4 v_position;


void main()
{
	vec3 n = normalize(mat3(u_normalMatrix)*a_normal);
	gl_Position=u_projMatrix*u_modelViewMatrix*vec4(a_position, 1.0);
	v_color.x = (n.x+1.0)/2.0;
	v_color.y = (n.y+1.0)/2.0;
	v_color.z = (n.z+1.0)/2.0;
	v_color.w = ((gl_Position.z/gl_Position.w)+1.0)/2.0;
}
