//VERTEXTSHADER_PRIMITIVEINCEDGE_BONETEXTURE
uniform mat4 u_modelViewMatrix;
uniform mat4 u_normalMatrix;
uniform mat4 u_projMatrix;
uniform float u_edgeStroke;
uniform vec4 u_edgeColor;
uniform sampler2D u_boneTex;

attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec2 a_floatIndices;
attribute float a_weights;

vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec4 br1 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 br2 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bp1 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bp2 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bi1 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bi2 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.y));

	vec3 p1 = qtransform(br1, (a_position-vec3(bi1))) + vec3(bp1);
	vec3 p2 = qtransform(br2, (a_position-vec3(bi2))) + vec3(bp2);
	vec3 n1 = qtransform(br1, a_normal);
	vec3 n2 = qtransform(br2, a_normal);

	vec3 pos = mix(p1, p2, a_weights);
	vec3 normal = mix(n1, n2, a_weights);
	vec4 position = vec4(pos+(normal*u_edgeStroke), 1.0);
	gl_Position = u_projMatrix*u_modelViewMatrix*position;
}
