//VERTEXTSHADER_PRIMITIVEANDSKINING_BONETEXTURE
uniform mat4 u_shadowMVPMatrix;
uniform sampler2D u_boneTex;

attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec2 a_floatIndices;
attribute float a_weights;

varying vec4 v_position;


vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec4 br1 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 br2 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bp1 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bp2 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bi1 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bi2 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.y));

	vec3 p1 = qtransform(br1, (a_position-vec3(bi1))) + vec3(bp1);
	vec3 p2 = qtransform(br2, (a_position-vec3(bi2))) + vec3(bp2);

	vec3 pos = mix(p1, p2, a_weights);
	v_position = u_shadowMVPMatrix*vec4(pos, 1.0);
	gl_Position = v_position;
}
