//VERTEXTSHADER_PRIMITIVEANDSKINING_DEPTHSHADOW
uniform vec4 u_boneCoordinates[${BoneCount}];	//	116
uniform vec4 u_bonePositions[${BoneCount}];		//	116 >>> (232 + 19)=251(htc j butterfly max specs)
uniform mat4 u_shadowMVPMatrix;

attribute vec3 a_position;
attribute vec2 a_indices;
attribute float a_weights;
attribute vec3 a_boneInitial1;
attribute vec3 a_boneInitial2;

varying vec4 v_position;


vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec3 p1 = qtransform(u_boneCoordinates[int(a_indices.x)], a_position-a_boneInitial1) + vec3(u_bonePositions[int(a_indices.x)]);
	vec3 p2 = qtransform(u_boneCoordinates[int(a_indices.y)], a_position-a_boneInitial2) + vec3(u_bonePositions[int(a_indices.y)]);
	vec3 pos = mix(p1, p2, a_weights);
	v_position = u_shadowMVPMatrix*vec4(pos, 1.0);
	gl_Position = v_position;
}
