//VERTEXTSHADER_PRIMITIVEA_BDEF4_DEPTHSHADOW
uniform mat4 u_shadowMVPMatrix;
uniform vec4 u_boneCoordinates[${BoneCount}];
uniform vec4 u_bonePositions[${BoneCount}];

attribute vec3 a_position;
attribute vec4 a_indices;
attribute vec4 a_weights;
attribute vec3 a_boneInitial1;
attribute vec3 a_boneInitial2;
attribute vec3 a_boneInitial3;
attribute vec3 a_boneInitial4;

varying vec4 v_position;

vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec3 p1 = qtransform(u_boneCoordinates[int(a_indices.x)], a_position-a_boneInitial1) + vec3(u_bonePositions[int(a_indices.x)]);
	vec3 p2 = qtransform(u_boneCoordinates[int(a_indices.y)], a_position-a_boneInitial2) + vec3(u_bonePositions[int(a_indices.y)]);
	vec3 p3 = qtransform(u_boneCoordinates[int(a_indices.z)], a_position-a_boneInitial3) + vec3(u_bonePositions[int(a_indices.z)]);
	vec3 p4 = qtransform(u_boneCoordinates[int(a_indices.w)], a_position-a_boneInitial4) + vec3(u_bonePositions[int(a_indices.w)]);
	vec3 pos = p1*a_weights.x + p2*a_weights.y + p3*a_weights.z + p4*a_weights.w;
	v_position = u_shadowMVPMatrix*vec4(pos, 1.0);
	gl_Position = v_position;
}
