//VERTEXTSHADER_PRIMITIVE_BDEF4_DEPTHSHADOW_BONETEXTURE_FLOATRGBANOTSUPPORTED
uniform mat4 u_shadowMVPMatrix;
uniform sampler2D u_boneTex;

attribute vec3 a_position;
attribute vec4 a_floatIndices;
attribute vec4 a_weights;

varying vec4 v_position;

vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
const float g_offset = 1.0/16.0;
const float g_harfOffset = g_offset*0.5;
vec4 loadVec4(float u, float v)
{
	vec4 result;
	result.x = texture2D(u_boneTex, vec2(u+g_harfOffset, v)).x;
	result.y = texture2D(u_boneTex, vec2(u+g_offset+g_harfOffset, v)).x;
	result.z = texture2D(u_boneTex, vec2(u+g_offset*2.0+g_harfOffset, v)).x;
	result.w = texture2D(u_boneTex, vec2(u+g_offset*3.0+g_harfOffset, v)).x;
	return result;
}
void main()
{
	vec4 br1 = loadVec4(0.0, a_floatIndices.x);
	vec4 bp1 = loadVec4(g_offset*4.0, a_floatIndices.x);
	vec4 bi1 = loadVec4(g_offset*8.0, a_floatIndices.x);
	vec4 br2 = loadVec4(0.0, a_floatIndices.y);
	vec4 bp2 = loadVec4(g_offset*4.0, a_floatIndices.y);
	vec4 bi2 = loadVec4(g_offset*8.0, a_floatIndices.y);
	vec4 br3 = loadVec4(0.0, a_floatIndices.z);
	vec4 bp3 = loadVec4(g_offset*4.0, a_floatIndices.z);
	vec4 bi3 = loadVec4(g_offset*8.0, a_floatIndices.z);
	vec4 br4 = loadVec4(0.0, a_floatIndices.w);
	vec4 bp4 = loadVec4(g_offset*4.0, a_floatIndices.w);
	vec4 bi4 = loadVec4(g_offset*8.0, a_floatIndices.w);

	vec3 p1 = qtransform(br1, a_position-vec3(bi1)) + vec3(bp1);
	vec3 p2 = qtransform(br2, a_position-vec3(bi2)) + vec3(bp2);
	vec3 p3 = qtransform(br3, a_position-vec3(bi3)) + vec3(bp3);
	vec3 p4 = qtransform(br4, a_position-vec3(bi4)) + vec3(bp4);
	vec3 pos = p1*a_weights.x + p2*a_weights.y + p3*a_weights.z + p4*a_weights.w;
	v_position = u_shadowMVPMatrix*vec4(pos, 1.0);
	gl_Position = v_position;
}
