//VERTEXTSHADER_TEXTUREANDSKINING
precision highp float;


uniform mat4 u_modelViewMatrix;
uniform mat4 u_normalMatrix;
uniform mat4 u_projMatrix;

uniform vec4 u_boneCoordinates[${BoneCount}];
uniform vec4 u_bonePositions[${BoneCount}];

attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec2 a_uv;
attribute vec2 a_indices;
attribute float a_weights;
attribute vec3 a_boneInitial1;
attribute vec3 a_boneInitial2;


varying vec3 v_position;
varying vec3 v_normal;
varying vec2 v_uv;


vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec3 p1 = qtransform(u_boneCoordinates[int(a_indices.x)], a_position-a_boneInitial1) + vec3(u_bonePositions[int(a_indices.x)]);
	vec3 p2 = qtransform(u_boneCoordinates[int(a_indices.y)], a_position-a_boneInitial2) + vec3(u_bonePositions[int(a_indices.y)]);
	vec3 n1 = qtransform(u_boneCoordinates[int(a_indices.x)], a_normal);
	vec3 n2 = qtransform(u_boneCoordinates[int(a_indices.y)], a_normal);
	vec3 pos = mix(p1, p2, a_weights);
	vec3 normal = mix(n1, n2, a_weights);
	vec4 position = u_modelViewMatrix*vec4(pos, 1.0);
	v_position = position.xyz;
	gl_Position = u_projMatrix*position;
	v_normal = mat3(u_normalMatrix)*normal;
	v_uv = a_uv;
}
