//VERTEXTSHADER_TEXTUREANDSKINING_BONETEXTURE.SHADOW
precision highp float;


uniform mat4 u_modelViewMatrix;
uniform mat4 u_normalMatrix;
uniform mat4 u_projMatrix;
uniform mat4 u_shadowMVPMatrix;
uniform sampler2D u_boneTex;

attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec2 a_uv;
attribute vec2 a_floatIndices;
attribute float a_weights;


varying vec3 v_position;
varying vec3 v_normal;
varying vec2 v_uv;
varying vec4 v_shadowCoord;


vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
const float g_offset = 1.0/16.0;
const float g_harfOffset = g_offset*0.5;
vec4 loadVec4(float u, float v)
{
	vec4 result;
	result.x = texture2D(u_boneTex, vec2(u+g_harfOffset, v)).x;
	result.y = texture2D(u_boneTex, vec2(u+g_offset+g_harfOffset, v)).x;
	result.z = texture2D(u_boneTex, vec2(u+g_offset*2.0+g_harfOffset, v)).x;
	result.w = texture2D(u_boneTex, vec2(u+g_offset*3.0+g_harfOffset, v)).x;
	return result;
}
void main()
{
	vec4 br1 = loadVec4(0.0, a_floatIndices.x);
	vec4 bp1 = loadVec4(g_offset*4.0, a_floatIndices.x);
	vec4 bi1 = loadVec4(g_offset*8.0, a_floatIndices.x);
	vec4 br2 = loadVec4(0.0, a_floatIndices.y);
	vec4 bp2 = loadVec4(g_offset*4.0, a_floatIndices.y);
	vec4 bi2 = loadVec4(g_offset*8.0, a_floatIndices.y);

	vec3 p1 = qtransform(br1, (a_position-vec3(bi1))) + vec3(bp1);
	vec3 p2 = qtransform(br2, (a_position-vec3(bi2))) + vec3(bp2);
	vec3 n1 = qtransform(br1, a_normal);
	vec3 n2 = qtransform(br2, a_normal);

	vec3 pos = mix(p1, p2, a_weights);
	vec3 normal = mix(n1, n2, a_weights);
	vec4 position = u_modelViewMatrix*vec4(pos, 1.0);
	v_position = position.xyz;
	gl_Position = u_projMatrix*position;
	v_normal = mat3(u_normalMatrix)*normal;
	v_uv = a_uv;

	v_shadowCoord = u_shadowMVPMatrix*vec4(pos, 1.0);
}
