//VERTEXTSHADER_TEXTURE_BDEF4_BONETEXTURE.SHADOW
precision highp float;


uniform mat4 u_modelViewMatrix;
uniform mat4 u_normalMatrix;
uniform mat4 u_projMatrix;
uniform mat4 u_shadowMVPMatrix;
uniform sampler2D u_boneTex;

attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec4 a_floatIndices;
attribute vec4 a_weights;
attribute vec2 a_uv;

varying vec3 v_position;
varying vec3 v_normal;
varying vec2 v_uv;
varying vec4 v_shadowCoord;


vec3 qtransform(vec4 q, vec3 v)
{
	return v + 2.0 * cross(cross(v, q.xyz) - q.w*v, q.xyz);
}
void main()
{
	vec4 br1 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 br2 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 br3 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.z));
	vec4 br4 = texture2D(u_boneTex, vec2(((1.0/4.0)*0.5), a_floatIndices.w));
	vec4 bp1 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bp2 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bp3 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.z));
	vec4 bp4 = texture2D(u_boneTex, vec2((1.0/4.0)+((1.0/4.0)*0.5), a_floatIndices.w));
	vec4 bi1 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.x));
	vec4 bi2 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.y));
	vec4 bi3 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.z));
	vec4 bi4 = texture2D(u_boneTex, vec2((1.0/4.0)*2.0+((1.0/4.0)*0.5), a_floatIndices.w));

	vec3 p1 = qtransform(br1, a_position-vec3(bi1)) + vec3(bp1);
	vec3 p2 = qtransform(br2, a_position-vec3(bi2)) + vec3(bp2);
	vec3 p3 = qtransform(br3, a_position-vec3(bi3)) + vec3(bp3);
	vec3 p4 = qtransform(br4, a_position-vec3(bi4)) + vec3(bp4);
	vec3 n1 = qtransform(br1, a_normal);
	vec3 n2 = qtransform(br2, a_normal);
	vec3 n3 = qtransform(br3, a_normal);
	vec3 n4 = qtransform(br4, a_normal);
	vec3 pos = p1*a_weights.x + p2*a_weights.y + p3*a_weights.z + p4*a_weights.w;
	vec3 normal = n1*a_weights.x + n2*a_weights.y + n3*a_weights.z + n4*a_weights.w;
	vec4 position = u_modelViewMatrix*vec4(pos, 1.0);
	v_position = position.xyz;
	gl_Position = u_projMatrix*position;
	v_normal = mat3(u_normalMatrix)*normal;
	v_uv = a_uv;

	v_shadowCoord = u_shadowMVPMatrix*vec4(pos, 1.0);
}
